diff --git a/src/test/modules/connect/connect.c b/src/test/modules/connect/connect.c
new file mode 100644
index 0000000000..c875b7647b
--- /dev/null
+++ b/src/test/modules/connect/connect.c
@@ -0,0 +1,26 @@
+#include <stdio.h>
+#include <winsock.h>
+
+int
+main(int argc, char *argv[])
+{
+	WSADATA	      wsaData;
+	SOCKET sock;
+	int port = 5432;
+	struct sockaddr_in ai_addr;
+	unsigned long ioctlsocket_ret = 1;
+
+	if (argc > 1) port = atoi(argv[1]);
+
+	ai_addr.sin_family = AF_INET;
+	ai_addr.sin_addr.s_addr = inet_addr("127.0.0.1");
+	ai_addr.sin_port = htons(port);
+
+	WSAStartup(MAKEWORD(1, 1), &wsaData);
+	sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
+	ioctlsocket(sock, FIONBIO, &ioctlsocket_ret);
+	connect(sock, (SOCKADDR *) & ai_addr, sizeof (ai_addr));
+	fprintf(stdout, "test\n");
+	WSACleanup();
+	return 0;
+}
diff --git a/src/test/modules/connect/t/000_connect.pl b/src/test/modules/connect/t/000_connect.pl
new file mode 100644
index 0000000000..bd23d1e419
--- /dev/null
+++ b/src/test/modules/connect/t/000_connect.pl
@@ -0,0 +1,25 @@
+use strict;
+use warnings;
+
+use PostgresNode;
+use TestLib;
+use Test::More;
+use Test::More tests => 100000;
+
+# start a server
+my $node = get_new_node('main');
+$node->init;
+$node->start;
+
+my $stdout;
+my $stderr;
+my @cmd = ('connect', $node->port);
+
+IPC::Run::run(\@cmd, '>', \$stdout, '2>', \$stderr);
+diag($stdout);
+diag($stderr);
+
+for (my $i =0; $i < 100000; $i++) {
+	IPC::Run::run(\@cmd, '>', \$stdout, '2>', \$stderr);
+	ok(defined $stdout && $stdout ne '');
+}
diff --git a/src/tools/msvc/Mkvcbuild.pm b/src/tools/msvc/Mkvcbuild.pm
index 20da7985c1..70959fbb24 100644
--- a/src/tools/msvc/Mkvcbuild.pm
+++ b/src/tools/msvc/Mkvcbuild.pm
@@ -43,6 +43,7 @@ my $contrib_extrasource = {
 	'seg'  => [ 'contrib/seg/segscan.l',   'contrib/seg/segparse.y' ],
 };
 my @contrib_excludes = (
+	'connect',
 	'bool_plperl',      'commit_ts',
 	'hstore_plperl',    'hstore_plpython',
 	'intagg',           'jsonb_plperl',
@@ -423,6 +424,10 @@ sub mkvcbuild
 	$zic->AddDirResourceFile('src/timezone');
 	$zic->AddReference($libpgcommon, $libpgport);
 
+	my $test_connect = $solution->AddProject('connect', 'exe', 'utils');
+	$test_connect->AddFile('src/test/modules/connect/connect.c');
+	$test_connect->AddLibrary('ws2_32.lib');
+
 	if (!$solution->{options}->{xml})
 	{
 		push @contrib_excludes, 'xml2';
